/*
 * Copyright (c) 2002-2003 MIPS Technologies, Inc.  All rights reserved.
 * 
 * Unpublished rights (if any) reserved under the copyright laws of the
 * United States of America and other countries.
 * 
 * This code is proprietary to MIPS Technologies, Inc. ("MIPS
 * Technologies").  Any copying, reproducing, modifying or use of this
 * code (in whole or in part) that is not expressly permitted in writing
 * by MIPS Technologies or an authorized third party is strictly
 * prohibited.  At a minimum, this code is protected under unfair
 * competition and copyright laws.  Violations thereof may result in
 * criminal penalties and fines.
 * 
 * MIPS Technologies reserves the right to change this code to improve
 * function, design or otherwise.  MIPS Technologies does not assume any
 * liability arising out of the application or use of this code, or of
 * any error or omission in such code.  Any warranties, whether express,
 * statutory, implied or otherwise, including but not limited to the
 * implied warranties of merchantability or fitness for a particular
 * purpose, are excluded.  Except as expressly provided in any written
 * license agreement from MIPS Technologies or an authorized third party,
 * the furnishing of this code does not give recipient any license to any
 * intellectual property rights, including any patent rights, that cover
 * this code.
 * 
 * This code shall not be exported or transferred for the purpose of
 * reexporting in violation of any U.S. or non-U.S. regulation, treaty,
 * Executive Order, law, statute, amendment or supplement thereto.
 * 
 * This code constitutes one or more of the following: commercial
 * computer software, commercial computer software documentation or other
 * commercial items.  If the user of this code, or any related
 * documentation of any kind, including related technical data or
 * manuals, is an agency, department, or other entity of the United
 * States government ("Government"), the use, duplication, reproduction,
 * release, modification, disclosure, or transfer of this code, or any
 * related documentation of any kind, is restricted in accordance with
 * Federal Acquisition Regulation 12.212 for civilian agencies and
 * Defense Federal Acquisition Regulation Supplement 227.7202 for
 * military agencies.  The use of this code by the Government is further
 * restricted in accordance with the terms of the license agreement(s)
 * and/or applicable contract terms and conditions covering this code
 * from MIPS Technologies or an authorized third party.
 */

/*
 * MIPS SDE kit MIPS MDI interface definitions
 */


#ifndef __ASSEMBLER__
extern int	_mdi_open (const char *, int, int);
extern int	_mdi_close (int);
extern int	_mdi_read (int, void *, int);
extern int	_mdi_write (int, const void *, int);
extern long	_mdi_lseek32 (int, long, int);
extern int	_mdi_getchar (int /*chan*/);
extern int	_mdi_putchar (int /*chan*/, int /*c*/);
struct timeval;
extern int	_mdi_gettime (struct timeval *);
extern int	_mdi_exit (int);
extern int	_mdi_isatty (int);
extern int	_mdi_syscall ();
extern int	_mdi_profil (int);
extern int	_mdi_sighook (int, void *);
#endif

#define _MDI_SYSCALL_OPEN	0
#define _MDI_SYSCALL_CLOSE	1
#define _MDI_SYSCALL_READ	2
#define _MDI_SYSCALL_WRITE	3
#define _MDI_SYSCALL_GETCHAR	4
#define _MDI_SYSCALL_PUTCHAR	5
#define _MDI_SYSCALL_LSEEK32	6
#define _MDI_SYSCALL_GETTIME	7
#define _MDI_SYSCALL_EXIT	8
#define _MDI_SYSCALL_MOVED	9
#define _MDI_SYSCALL_GETARGS	10
#define _MDI_SYSCALL_ISATTY	11
#define _MDI_SYSCALL_PROFIL	12
#define _MDI_SYSCALL_SIGHOOK	13
