/*
 * Copyright (c) 1996-2003 MIPS Technologies, Inc.  All rights reserved.
 * 
 * Unpublished rights (if any) reserved under the copyright laws of the
 * United States of America and other countries.
 * 
 * This code is proprietary to MIPS Technologies, Inc. ("MIPS
 * Technologies").  Any copying, reproducing, modifying or use of this
 * code (in whole or in part) that is not expressly permitted in writing
 * by MIPS Technologies or an authorized third party is strictly
 * prohibited.  At a minimum, this code is protected under unfair
 * competition and copyright laws.  Violations thereof may result in
 * criminal penalties and fines.
 * 
 * MIPS Technologies reserves the right to change this code to improve
 * function, design or otherwise.  MIPS Technologies does not assume any
 * liability arising out of the application or use of this code, or of
 * any error or omission in such code.  Any warranties, whether express,
 * statutory, implied or otherwise, including but not limited to the
 * implied warranties of merchantability or fitness for a particular
 * purpose, are excluded.  Except as expressly provided in any written
 * license agreement from MIPS Technologies or an authorized third party,
 * the furnishing of this code does not give recipient any license to any
 * intellectual property rights, including any patent rights, that cover
 * this code.
 * 
 * This code shall not be exported or transferred for the purpose of
 * reexporting in violation of any U.S. or non-U.S. regulation, treaty,
 * Executive Order, law, statute, amendment or supplement thereto.
 * 
 * This code constitutes one or more of the following: commercial
 * computer software, commercial computer software documentation or other
 * commercial items.  If the user of this code, or any related
 * documentation of any kind, including related technical data or
 * manuals, is an agency, department, or other entity of the United
 * States government ("Government"), the use, duplication, reproduction,
 * release, modification, disclosure, or transfer of this code, or any
 * related documentation of any kind, is restricted in accordance with
 * Federal Acquisition Regulation 12.212 for civilian agencies and
 * Defense Federal Acquisition Regulation Supplement 227.7202 for
 * military agencies.  The use of this code by the Government is further
 * restricted in accordance with the terms of the license agreement(s)
 * and/or applicable contract terms and conditions covering this code
 * from MIPS Technologies or an authorized third party.
 */

/*
 * MIPS SDE kit pmon interface definitions
 */


/* this is the structure passed to PMON's onintr() function */
struct pmonhandler {
    struct pmonhandler *prev;
    void	(*addr)();
    int		enabled;	/* this is our own flag */
};


extern int pmon_open (const char *name, int flags);
extern int pmon_read (int fd, void *buf, int);
extern int pmon_write (int fd, const void *buf, int);
extern int pmon_ioctl (int fd, int cmd, void *arg);
extern int pmon_close (int fd);
extern void pmon_onintr (int xcptno, struct pmonhandler *h);

extern char *pmon_getenv (const char *s);

/* pmon_ioctl opcodes */
#define PMON_TCGETA	1
#define PMON_TCSETAF	2
#define PMON_TCSETAW	3
#define PMON_SETINTR	4
#define PMON_SETSANE	5
#define PMON_FIONREAD	6
#define PMON_GETINTR	7
#define PMON_SETNCNE	10
#define PMON_CBREAK	11

/* iflags */
#define PMON_ISTRIP	0x0020
#define PMON_ICRNL	0x0040
#define PMON_IXON	0x0400
#define PMON_IXANY	0x0800
#define PMON_IXOFF	0x1000

/* oflags */
#define PMON_ONLCR	0x0004

/* lflags */
#define PMON_ISIG	0x0001
#define PMON_ICANON	0x0002
#define PMON_ECHO	0x0008
#define PMON_ECHOE	0x0010

/* cflags */
#define	PMON_CBAUD	0000017		
#define	PMON_B0		0000000
#define	PMON_B50	0000001	
#define	PMON_B75	0000002
#define	PMON_B110	0000003
#define	PMON_B134	0000004
#define	PMON_B150	0000005
#define	PMON_B200	0000006
#define	PMON_B300	0000007
#define	PMON_B600	0000010
#define	PMON_B1200	0000011
#define	PMON_B1800	0000012
#define	PMON_B2400	0000013
#define	PMON_B4800	0000014
#define	PMON_B9600	0000015
#define	PMON_B19200	0000016
#define	PMON_B38400	0000017

/* cc definitions */
#define PMON_VINTR	0
#define PMON_VERASE	2
#define PMON_VEOL	5
#define PMON_VEOL2	6
#define PMON_VSTART	8
#define PMON_VSTOP	9
#define PMON_NCC 	23

struct pmontermio {
    unsigned short	c_iflag;
    unsigned short	c_oflag;
    unsigned short	c_cflag;
    unsigned short	c_lflag;
    unsigned char	c_cc[PMON_NCC];
};
